org.apache.solr.search

## Class LRUCache<K,V>

- java.lang.Object
- - org.apache.solr.search.SolrCacheBase
  - - org.apache.solr.search.LRUCache<K,V>

- All Implemented Interfaces:
    Accountable, SolrInfoMBean, SolrCache<K,V>

      public class LRUCache<K,V>
      extends SolrCacheBase
      implements SolrCache<K,V>, Accountable

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.solr.search.SolrCacheBase

      `SolrCacheBase.AutoWarmCountRef`

    - ### Nested classes/interfaces inherited from interface org.apache.solr.search.SolrCache

      `SolrCache.State`

    - ### Nested classes/interfaces inherited from interface org.apache.solr.core.SolrInfoMBean

      `SolrInfoMBean.Category`

  - ### Field Summary

    - ### Fields inherited from class org.apache.solr.search.SolrCacheBase

      `autowarm, regenerator`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LRUCache()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` :TODO: copy from Map
    `void` | `close()` Frees any non-memory resources
    `V` | `get(K key)` :TODO: copy from Map
    `Collection<Accountable>` | `getChildResources()`
    `String` | `getDescription()` Simple one or two line description
    `String` | `getName()` Simple common usage name, e.g.
    `String` | `getSource()` CVS Source, SVN Source, etc
    `NamedList` | `getStatistics()` Any statistics this instance would like to be publicly available via the Solr Administration interface.
    `Object` | `init(Map args, Object persistence, CacheRegenerator regenerator)` The initialization routine.
    `V` | `put(K key, V value)` :TODO: copy from Map
    `long` | `ramBytesUsed()`
    `int` | `size()` :TODO: copy from Map
    `String` | `toString()`
    `void` | `warm(SolrIndexSearcher searcher, SolrCache<K,V> old)` Warm this cache associated with `searcher` using the `old` cache object.

    - ### Methods inherited from class org.apache.solr.search.SolrCacheBase

      `calcHitRatio, getAutowarmDescription, getCategory, getDocs, getState, getVersion, init, isAutowarmingOn, name, setState`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.solr.search.SolrCache

      `getState, name, setState`

    - ### Methods inherited from interface org.apache.solr.core.SolrInfoMBean

      `getCategory, getDocs, getVersion`

- - ### Constructor Detail

    - #### LRUCache

          public LRUCache()

  - ### Method Detail

    - #### init

          public Object init(Map args,
                             Object persistence,
                             CacheRegenerator regenerator)

      Description copied from interface: `SolrCache`
      The initialization routine. Instance specific arguments are passed in the `args` map.

      The persistence object will exist across different lifetimes of similar caches. For example, all filter caches will share the same persistence object, sometimes at the same time (it must be thread-safe). If null is passed, then the cache implementation should create and return a new persistence object. If not null, the passed in object should be returned again.

      Since it will exist across the lifetime of many caches, care should be taken to not reference any particular cache instance and prevent it from being garbage collected (no using inner classes unless they are static).

      The persistence object is designed to be used as a way for statistics to accumulate across all instances of the same type of cache, however the object may be of any type desired by the cache implementation.

      The `CacheRegenerator` is what the cache uses during auto-warming to regenerate an item in the new cache from an entry in the old cache.

      Specified by:
        `init` in interface `SolrCache<K,V>`

    - #### size

          public int size()

      Description copied from interface: `SolrCache`
      :TODO: copy from Map
      Specified by:
        `size` in interface `SolrCache<K,V>`

    - #### put

          public V put(K key,
                       V value)

      Description copied from interface: `SolrCache`
      :TODO: copy from Map
      Specified by:
        `put` in interface `SolrCache<K,V>`

    - #### get

          public V get(K key)

      Description copied from interface: `SolrCache`
      :TODO: copy from Map
      Specified by:
        `get` in interface `SolrCache<K,V>`

    - #### clear

          public void clear()

      Description copied from interface: `SolrCache`
      :TODO: copy from Map
      Specified by:
        `clear` in interface `SolrCache<K,V>`

    - #### warm

          public void warm(SolrIndexSearcher searcher,
                           SolrCache<K,V> old)

      Description copied from interface: `SolrCache`
      Warm this cache associated with `searcher` using the `old` cache object. `this` and `old` will have the same concrete type.
      Specified by:
        `warm` in interface `SolrCache<K,V>`

    - #### close

          public void close()

      Description copied from interface: `SolrCache`
      Frees any non-memory resources
      Specified by:
        `close` in interface `SolrCache<K,V>`

    - #### getName

          public String getName()

      Description copied from interface: `SolrInfoMBean`
      Simple common usage name, e.g. BasicQueryHandler, or fully qualified clas name.
      Specified by:
        `getName` in interface `SolrInfoMBean`

    - #### getDescription

          public String getDescription()

      Description copied from interface: `SolrInfoMBean`
      Simple one or two line description
      Specified by:
        `getDescription` in interface `SolrInfoMBean`

    - #### getSource

          public String getSource()

      Description copied from interface: `SolrInfoMBean`
      CVS Source, SVN Source, etc
      Specified by:
        `getSource` in interface `SolrInfoMBean`

    - #### getStatistics

          public NamedList getStatistics()

      Description copied from interface: `SolrInfoMBean`
      Any statistics this instance would like to be publicly available via the Solr Administration interface.

      Any Object type may be stored in the list, but only the `toString()` representation will be used.

      Specified by:
        `getStatistics` in interface `SolrInfoMBean`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### ramBytesUsed

          public long ramBytesUsed()

      Specified by:
        `ramBytesUsed` in interface `Accountable`

    - #### getChildResources

          public Collection<Accountable> getChildResources()

      Specified by:
        `getChildResources` in interface `Accountable`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.